## gexec 0.4

=== Makefile ===
CC = gcc
LIBS = `pkg-config --libs gtk+-2.0`
INCS = `pkg-config --cflags gtk+-2.0`

FLAGS = -Wall -g

main: gexec
gexec: autocomp.o gexec.o
	$(CC) autocomp.o gexec.o -o gexec $(LIBS) $(INCS) $(FLAGS)
	strip gexec
gexec.o: gexec.c
	$(CC) -c gexec.c $(INCS) $(FLAGS)
autocomp.o: autocomp.c autocomp.h
	$(CC) -c autocomp.c $(INCS) $(FLAGS)
clean:
	-rm gexec
	-rm *.o
install:
	-cp gexec /usr/local/bin
	-cp gexec.1 /usr/local/man/man1/

=== debian/changelog ===
gexec (0.4-3) unstable; urgency=low

  * New maintainer (Closes: #834986)
  * Updated to debhelper 12
  * Deleted trailing whitespace
  * Added Rules-Requires-Root
  * Added upstream/metadata
  * Standards version 4.5.0

 -- Seunghun Han <kkamagui@gmail.com>  Sat, 21 Mar 2020 00:13:36 +0900

gexec (0.4-2) unstable; urgency=medium

  * QA upload.
  * Set maintainer to Debian QA Group
  * Updated to debhelper 10
  * Enabled build hardening
  * Converted copyright to DEP-5
  * Removed redundant watch file
  * Added homepage
  * Standards version 3.9.8

 -- David William Richmond Jones <dwrj87@gmail.com>  Tue, 22 Nov 2016 08:14:53 +0000

gexec (0.4-1) unstable; urgency=low

  * New upstream release (closes: #413614)
  * debian/gexec.1: removed, it's now included in upstream source

 -- Johann Rudloff <cypheon@gmx.net>  Mon,  2 Apr 2007 10:43:03 +0200

gexec (0.3-1) unstable; urgency=low

  * Initial release

 -- Johann Rudloff <cypheon@gmx.net>  Wed, 17 Jan 2007 07:04:57 +0100

=== debian/control ===
Source: gexec
Section: x11
Priority: optional
Maintainer: Seunghun Han <kkamagui@gmail.com>
Build-Depends: debhelper (>= 12), libgtk2.0-dev, libglib2.0-dev
Homepage: https://github.com/fboender/gexec
Rules-Requires-Root: no
Standards-Version: 4.5.0

Package: gexec
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: gksu, xterm
Description: Small command executer with autocompletion using GTK+
 gexec is a small and simple command executer using GTK+. It features
 autocompletition and a command history. Furthermore gexec can run
 the chosen command as root or in a terminal emulator.

=== debian/rules ===
#!/usr/bin/make -f
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
#export DH_OPTIONS=-v

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh  $@

## gexec 0.5.4.1~ski

=== debian/changelog ===
gexec (0.5.4.1~ski) unstable; urgency=medium

  * bugfix: resolve malloc() error observed on 32-bit systems
  * handle (refuse) excessively long commandstrings.
  * removed % (percent char) from blacklisted chars.
    (rationale: given the absence of curly braces, it should be considered harmless)
  * Update gexec.c 
  * all work done by skidoo - pakaged by anticapitalista for antiX-buster/sid

 -- anticapitalista <antix@operamail.com>  Fri, 12 Apr 2019 19:31:41 +0300

gexec (0.5.4) unstable; urgency=medium

  * Upon first use by a given user, gexec will remove any its (from prior versions)
    pre-existing settings files from the user's home directory. It will create,
    if found missing, a ~/.config/gexec/ directory. Each run, plaintext files
    "gexec.conf" and "gexec__history" are created therein and will be regenerated
    if found missing. (Missing, as in, accidentally deleted, or had been excluded
    during antiX persist-save // live-remaster // snapshot operation).

  * Supplemental to the above, gexec will test to detect (similar to 'which xterm')
    available terminal emulator applications, automatically populating the
    default choice within its settings file. Currently (subject to change) the order
    of preference when checking/autoselecting a terminal emulator application is:
    urxvt, roxterm, xfce4-terminal, xterm. If none of these are available, gexec will
    fallback to assigning x-terminal-emulator within its settings file.

  * gexec.conf stores two user-reconfigurable gexec configuration options:
      - cmd_termemu (terminal emulator program called if "Run in terminal" is ticked).
      - history_max (self-explanatory, prepopulated default value = 40)
    As explained in the manpage, history logging can disabled by specifying hist_max=0
    within the gexec.conf file

  * The expanded manpage now mentions the possibility to edit gexec config file,
    in addition to mentioning availability of runtime options. 

  * manpage now lists features/quirk specific each of several terminal emulator
    programs, and provides a suitable example gexec.conf line for each of them.

  * Toward avoiding redundant history entries, commandstrings are now trimmed of
    leading/trailing space before beinging added to the history list

  * a notable bulletpoint change from previous versions:
    When "run as Root" is selected, gexec is now hardcoded to invoke the gksu program.
  
  * history_max (default: 40); Does not store multiple records of identical commandstrings.

  * usability tweak: added attribute "always open center of screen" for the gexec window

  * To preclude mindlessly pressing Enter key and accidentally (re)running a
    previously-issued command when items exist in the gexec history, upon launch, the
    command entry box will _NOT_ be pre-populated with the most-recently-used command.
    (todo: this behavior could, instead, become a configurable user option)

  * Supplemental to the above: when KeepOpen is in effect, the RunAsRoot option will be
    automatically de-selected (must be re-selected) each time a program is launched.

  * tickbox "Run as root" is not displayed if the user is already running as root
    (although that should never occur, riiiiight?)

  * related to the above: each time the user PASTES text into the runbox, gexec displays
    a warning dialog mentioning "pasting commandstrings from web pages or other rich-text
    encoded documents is ill-advised". By design, this warn-on-paste popup 
    (is non-configurable) cannot be disabled.

  * Makefile: merged debian patches (00_previous.patch and 01_buildflags.patch)

  * added a statement into the manpage stating the copy/paste warning, along with
    several reference pages (archive.org URLs) which provide detailed explanations
    of the risks.

  * todo: choose a consistent behavior regarding paste events. Currently, a paste
    from clipboard operation generates a "nag" but, ultimately, is allowed...
    vs paste from primary selection (which is currently nagged+blocked)

  * debian has nixed the gexec package bugtracker page.
    Check for reported bugs, and pull requests, across other distros.
    (done: only 1 found ~~ "Display "Run as root" checkbox only if not running as root")

  * Currently, by design, gexec history does store "failed" commandstrings.
    If it did not do so, the user would lose ability to scrollback and examine
    "What did I type last time?" toward editing/fixing the previously attempted
    command. TODO: upon addition of a gexec logging feature, reconsider whether
    failed commands should be excluded from history. Ultimately, gexec is blind
    to the success/failure in terms of the user's desired or expected outcome;
    the launched child process is, essentially, immediately disowned and forgotten.

  * as of v0.5.4, gexec now enforces a much more strict set of "forbidden" characters,
    compared to the shell_escape() typically performed by other runner programs.
    (Further testing may uncover a need to relax the set of characters.)
    Also (begs ongoing further testing) gexec currently does not shell_quote() each
    argv portion of the commandstring passed to backend terminal or to gksu,
    nor does it encase the entire passed commandstring in quotes. This behavior
    is intended to avoid QUIRKS noticed across tested terminal emulator programs
    and to hopefully better achieve UTF-8 support, and to achieve clean (WYSIWYG)
    input when passing to gksu.

  * noted (unchanged): with the expectation that gexec will be assigned to a
    keybind, the package does not ship a .desktop file

  * disabled the --name=NAME option (caller could alter the namestring displayed
    in gexec's window! Why?) (the option was provided by, inherited from, GTK+)

  * removed the tabbed autocompletion feature. Confusingly, it had matched against
    names of programs throughout pathed directories, but NOT from gexec history.


=== debian/control ===
Source: gexec
Section: x11
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends: debhelper (>= 10), libgtk2.0-dev, libglib2.0-dev
Homepage: https://gitlab.com/skidoo/gexec
Standards-Version: 3.9.8

Package: gexec
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, gksu
Suggests: xterm
Description: 
 gexec displays an interactive command execution dialog (aka runner, runbox).
 Its features include saved history, and options to specify "run in terminal",
 "run as root", and "Keep Open this dialog after launch".

## gexec 0.5.4.2~ski

=== Makefile ===
CC = gcc
LIBS = `pkg-config --libs gtk+-2.0`
INCS = `pkg-config --cflags gtk+-2.0`

CFLAGS += -Wall -g
CFLAGS += $(CPPFLAGS)

main: gexec
gexec: gexec.o
	$(CC) gexec.o -o gexec $(LDFLAGS) $(LIBS)
gexec.o: gexec.c
	$(CC) -c gexec.c $(INCS) $(CFLAGS)
clean:
	rm -f gexec
	rm -f *.o
install:
	install -m755 -D gexec $(DESTDIR)/usr/bin/gexec
	install -m644 -D gexec.1 $(DESTDIR)/usr/share/man/man1/gexec.1

=== debian/changelog ===
gexec (0.5.4.2~ski) unstable; urgency=medium

  * use short description in control file

 -- anticapitalista <antix@operamail.com>  Thu, 04 Jul 2019 16:14:34 +0300

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, gksu
 Suggests: xterm
-Description: 
+Description: interactive command execution dialog
  gexec displays an interactive command execution dialog (aka runner, runbox).
  Its features include saved history, and options to specify "run in terminal",
  "run as root", and "Keep Open this dialog after launch".

=== debian/rules ===
--- 
+++ 
@@ -8,3 +8,4 @@
 
 %:
 	dh  $@
+
